6a55e4406455b436292444cba56a344a7705a23d
[automated-distro-installer] / fai / config / scripts / GRUB_PC / 11-ian
1 #!/bin/bash -x
2
3 set -eE -o pipefail
4 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
5
6 if [[ $EUID != 0 ]]; then
7 echo "$0: error: expected to be root."
8 exit 1
9 fi
10
11 if ! type -t fcopy &>/dev/null; then
12 sudo apt-get -y install fai-client
13 fi
14
15 chroot $FAI_ROOT bash <<'EOFOUTER'
16 if getent group systemd-journal >/dev/null; then
17 # makes the journal be saved to disk.
18 mkdir -p /var/log/journal
19 chmod 755 /var/log/journal
20 fi
21 debconf-set-selections <<EOF
22 kexec-tools kexec-tools/load_kexec boolean false
23 EOF
24 apt-get install -y pxe-kexec
25 EOFOUTER
26
27 # -r = recursive
28 # -i = ignore non-matching class warnings, always exit 0
29 # -B = no backup files
30 fcopy -riB /boot
31 # this is also done by FABASE/10-misc by default.
32 fcopy -riB /root
33 if ifclass STABLE_BOOTSTRAP; then
34 fcopy -ri /etc/systemd/system
35 chroot $FAI_ROOT bash <<'EOFOUTER'
36 systemctl enable fai_check.service
37 EOFOUTER
38 exit 0
39 fi
40
41
42 src=$FAI/distro-install-common/shadow
43 dst=/q/root/shadow
44 if [[ ! -e $dst && -e $src ]]; then
45 # outside of fai context, we skip this
46 mkdir -p $dst
47 mount -o bind $src $dst
48 fi
49 # todo, port this over to the arch install script.
50 src=$FAI/distro-install-common/p/c/machine_specific/$HOSTNAME/filesystem/etc/ssh
51 dst=/target/etc/ssh
52 if [[ -e $src && -e $dst ]]; then
53 # outside of fai context, we skip this
54 cp -rT $src
55 fi
56
57 $FAI/distro-install-common/end
58
59 # these get copied in an earlier stage by fai, but leaving it here since
60 # I run this as a single post-fai script to update things that have changed.
61 fcopy -riB /etc/apt
62 # outside of fai, this seems to regularly lead to
63 # E: Could not get lock /var/lib/apt/lists/lock - open (11: Resource temporarily unavailable)
64 # so add a sleep. 1 sec is probably way more than needed.
65 sleep 1
66 $ROOTCMD apt-get update
67
68 fcopy -riB /etc/ssh
69
70 chroot $FAI_ROOT bash <<'EOF'
71 set -eE -o pipefail
72 mkdir -p /home/ian/.ssh
73 f=/root/.ssh/authorized_keys
74 if [[ -e $f ]]; then
75 cp $f /home/ian/.ssh
76 fi
77 chown -R 1000:1000 /home/ian/.ssh
78 chmod -R u=Xrw,og= /home/ian/.ssh
79 rm -rf /root/.ssh
80 cp -rL /home/ian/.ssh /root
81 chown -R root:root /root/.ssh
82 chmod 700 /root/.ssh
83
84
85 # default jessie groups + kvm, systemd-journal, adm
86 usermod -aG adm,cdrom,floppy,sudo,audio,dip,video,plugdev,netdev ian
87
88 if getent group systemd-journal >/dev/null; then
89 usermod -aG systemd-journal ian
90 fi
91 # https://askubuntu.com/questions/33416/how-do-i-disable-the-boot-splash-screen-and-only-show-kernel-and-boot-text-inst
92 # it suggests not having plymouth-theme-ubuntu-text, but
93 # making it not installed then kills plymouth, then makes
94 # the system not boot.
95 sed -ri 's/(^ *GRUB_CMDLINE_LINUX.*)quiet splash/\1/' /etc/default/grub
96 # on xenial, no grub is displayed at all. fix that.
97 # found just by noticing this in the config file, and a
98 # warning about it in error.log
99 sed -i '/^ *GRUB_HIDDEN_TIMEOUT/d' /etc/default/grub
100 update-grub2
101 EOF
102
103
104 # reading through the groups that ian is in but traci isn't,
105 for g in plugdev audio video cdrom; do
106 $ROOTCMD usermod -a -G $g traci
107 done